@
\mathchardef\RA="3221 % right arrow
\mathchardef\BA="3224 % double arrow
Here is a table of all the productions.  Each production that
combines two or more consecutive scraps implicitly inserts a {\tt \$}
where necessary, that is, between scraps whose abutting boundaries
have different |mathness|.  In this way we never get double {\tt\$\$}.

A translation is provided when the resulting scrap is not merely a
juxtaposition of the scraps it comes from.  An asterisk$^*$ next to a scrap
means that its first identifier gets an underlined entry in the index,
via the function |make_underlined|.  Two asterisks$^{**}$ means that both
|make_underlined| and |make_reserved| are called; that is, the
identifier's ilk becomes |int_like|.  We use \\{in}, \\{out}, \\{back} and
\\{bsp} as shorthands for |indent|, |outdent|, |backup| and
|break_space|, respectively.

\begingroup \lineskip=4pt
\def\tspan{\omit&&\omit\hfil\hskip-300pt}
\def\alt #1 #2
{$\displaystyle\Bigl\{\!\matrix{\strut\hbox{#1}\cr
   \strut\hbox{#2}\cr}\!\Bigr\}$ }
\def\altt #1 #2 #3
{$\displaystyle\Biggl\{\!\matrix{\strut\hbox{#1}\cr\hbox{#2}\cr
   \strut\hbox{#3}\cr}\!\Biggr\}$ }
\def\altttttt #1 #2 #3 #4 #5 #6 #7
{$\displaystyle\left\{\!\matrix{\strut\hbox{#1}\cr\hbox{#2}\cr
   \strut\hbox{#3}\cr\strut\hbox{#4}\cr\strut\hbox{#5}\cr\strut\hbox{#6}\cr
   \strut\hbox{#7}\cr}\!\right\}$ }
\def\malt #1 #2
{$\displaystyle\matrix{\strut\hbox{#1}\hfill\cr\strut\hbox{#2}\hfill\cr}$}
\def\maltt #1 #2 #3
{$\displaystyle\matrix{\strut\hbox{#1}\hfill\cr\hbox{#2}\hfill\cr
   \strut\hbox{#3}\hfill\cr}$}
\def\newprod#1{\omit\hfil\it#1\enspace}
{
\yskip\newcount\prodno\prodno=0\def\ignore#1{}
\halign to\hsize{\hfil\it\number\prodno \global\advance\prodno by1
 \ignore{#}\enspace&\strut#\hfil\tabskip 0pt plus 200pt&%
$\RA$ #\hfil&$\quad$#\hfil\tabskip0pt\cr
\omit & LHS & RHS \hfill Translation & Example\cr
\noalign{\yskip}
& \altt\\{any} {\\{any} \\{any}} {\\{any} \\{any} \\{any}}
|insert| & \altt\\{any} {\\{any} \\{any}} {\\{any} \\{any} \\{any}}
& stmt; \ /$\ast\,$comment$\,*$/\cr
& |exp| \altt|lbrace| |int_like| |decl|
    & |fn_decl| \altt|lbrace| |int_like| |decl|
        \hfill $F=E^*\,|in|\,|in|$ & \malt {\\{main}()$\{$}
           {\\{main}$(\\{ac},\\{av})$ \&{int} \\{ac};} \cr
& |exp| |unop| & |exp| & |x++|\cr
& |exp| \alt |binop| |unorbinop| |exp| & |exp| & \malt {|x+y|} {|x*y|} \cr
& |exp| |comma| |exp| & |exp| \hfill $E_1C\,|opt|9\,E_2$& |f(x,y)|\cr
& |exp| |exp| & |exp| & |time()|\cr
& |exp| |semi| & |stmt| & |x=0;|\cr
& |exp| |colon| & |tag| \hfill $E^*C$ & |found:|\cr
& |lpar| |exp| |rpar| & |exp| & |(x+y)|\cr
& |lpar| |rpar| & |exp| \hfill $L\.{\\,}R$ & functions, declarations\cr
& |lpar| \alt |decl_head| |int_like| |rpar| & |cast| & |(char*)|\cr
\newprod{115}& |lpar| \alt|decl_head| |int_like| |comma| & |lpar| &
               argument list\cr
& |lpar| |stmt| & |lpar| \hfill $LS\.\ $ & |for| constructions\cr
& |question| |exp| |colon| & |binop| & |x==y?x+1:0|\cr
& |unop| \alt |exp| |int_like| & \alt |exp| |int_like| &
         \malt |!x| destructors \cr
& |unorbinop| \alt|exp| |int_like| & |exp| \hfill $\.\{U\.\}E$ & |*x|\cr
& |unorbinop| |binop| & |binop| \hfill $|math_rel|\,U\.\{B\.\}\.\}$ & |*=|\cr
& |binop| |binop| & |binop| \hfill
                        $|math_rel|\,\.\{B_1\.\}\.\{B_2\.\}\.\}$ & |x>>=y|\cr
& |cast| |exp| & |exp| \hfill $C\.\ E$ & |(double)x|\cr
& |sizeof_like| |cast| & |exp| & |sizeof (double)|\cr
\newprod{112}& |sizeof_like| \alt |unorbinop| |binop| |binop| &
               |sizeof_like| |binop| \hfill $B=\.\{U\.\}\.\{B\.\}$ &
               |operator*=|\cr
\newprod{100}& |sizeof_like| |exp| |int_like| & |exp| \hfill $SE\.\ I$ &
                             |new(z) char|\cr
& |sizeof_like| \altttttt |exp| |int_like| |unorbinop| |binop| |unop|
                |sizeof_like| |comma| & |exp| \hfill $S\.\ E$ &
                \maltt {|sizeof x|} {|new char|} {|operator+|} \cr
& |int_like| \alt|int_like| |struct_like| &
        \alt|int_like| |struct_like| \hfill $I\.\ $\alt $I$ $S$
        \unskip& |extern char|\cr
& |int_like| \altt|exp| |unorbinop| |semi| & |decl_head|
                    \altt|exp| |unorbinop| |semi| \hfill
                   $D=I$\altt{\.\ } {\.\ } {} \unskip & |int x|\cr
\newprod{101}& |int_like| |comma| |int_like| & |int_like|
                          \hfill $I_1C\,|opt|9\,I_2$& |int f(int,int)|\cr
\newprod{102}& |int_like| |lpar| |exp| |rpar| & |exp| & |int(x)|\cr
\newprod{111}& |int_like| |cast| & |decl_head| & constructors\cr
\newprod{103}& |decl_head| |comma| |int_like| &
                |decl_head| \hfill $DC\.\ I\.\ $ & |int huge *p, huge *q|\cr
& |decl_head| |comma| & |decl_head| \hfill $DC\.\ $ & |int x,y|\cr
\newprod{104}& |decl_head| |unorbinop| |int_like| &
               |decl_head| \hfill $D\.\{U\.\}I\.\ $ & |int *const|\cr
& |decl_head| |unorbinop| & |decl_head| \hfill $D\.\{U\.\}$ & |int *x|\cr
& |decl_head| |exp| & |decl_head| \hfill $DE^*$ & |int x|\cr
& |decl_head| \alt|binop| |colon| |exp| \altt|comma| |semi| |rpar| &
     |decl_head| \altt|comma| |semi| |rpar| \quad
     $D=D$\alt $B$ $C$ \unskip$E$ &
     \maltt initialization fields {default argument} \cr
\newprod{105}& |decl_head| |cast| & |decl_head| & |int f(int x)|\cr
& |decl_head| \altt|int_like| |lbrace| |decl| & |fn_decl|
                   \altt|int_like| |lbrace| |decl| \hfill $F=D\,|in|\,|in|$
                             & |long time () {|\cr
& |decl_head| |semi| & |decl| & |int n;|\cr
& |decl| |decl| & |decl| \hfill $D_1\,|force|\,D_2$ & |int n;double x;|\cr
& |decl| \alt|stmt| |function| & \alt|stmt| |function|
        \hfill $D\,$\alt $|force|\,S$ $|big_force|\,F$ \unskip& \&{extern} $n$;
            \\{main} ()|{}|\cr
& |typedef_like| |decl_head| \alt|exp| |int_like| & |typedef_like| |decl_head|
                        \hfill $D=DE^{**}$ & \&{typedef} \&{char} \&{ch};\cr
& |typedef_like| |decl_head| |semi| & |decl| \hfill $T\.\ D$ &
                                             \&{typedef} \&{int} $\&x,\&y$;\cr
& |struct_like| |lbrace| & |struct_head| \hfill $S\.\ L$ & |struct {|\cr
& |struct_like| \alt|exp| |int_like|
 |lbrace| & |struct_head| \hfill $S\.\ E^{**}\.\ L$
                                            & \&{struct} \&{name\_info} $\{$\cr
\newprod{106}& |struct_like| |colon| \altt |exp| |int_like| |case_like| &
               |struct_like| |colon| \hfill $C=C\.\ E$ & derived classes\cr
\newprod{113}& |struct_like| |colon| |comma| &
               |struct_like| |colon| \hfill $C=CC\.\ $ & ditto\cr
\newprod{107}& |struct_like| |colon| & |struct_like| \hfill $S\.\ C$ & ditto\cr
\newprod{108}& \multispan2\strut |struct_like| \alt |exp| |int_like| |colon|
               \altt |exp| |int_like| |case_like| \hfil\cr
               \omit & & |struct_like| \alt |exp| |int_like| |colon|\cr
        \tspan $C=C\.\ E$ & ditto\cr
\newprod{114}& \multispan2\strut |struct_like| \alt |exp| |int_like| |colon|
               |comma|\hfil\cr
               \omit & & |struct_like| \alt |exp| |int_like| |colon|\cr
        \tspan $C=CC\.\ $ & ditto\cr
\newprod{109}& |struct_like| \alt |exp| |int_like| |colon| &
               |struct_like| \alt |exp| |int_like| \hfill $E=E\.\ C$ & ditto\cr
& |struct_like| \alt|exp| |int_like| & |int_like| \hfill $S\.\ E$
                                          & \&{struct} \&{name\_info} $z$;\cr
& |struct_head| \altt |decl| |stmt| |function| |rbrace| & |int_like|\hfill
         $S\,\\{in}\,|force|\,D\,\\{out}\,|force|\,R$ &
                                        |struct {| declaration |}|\cr
& |fn_decl| |decl| & |fn_decl| \hfill $F\,|force|\,D$
                                       & $f(z)$ \&{double} $z$; \cr
& |fn_decl| |stmt| & |function| \hfill $F\,|out|\,|out|\,|force|\,S$
                                       & \\{main}() {\dots}\cr
& |function| \alt |decl| |function| & \alt |decl| |function| \hfill
  $F\,|big_force|\,$\alt $D$ $F$ & outer block\cr
& |lbrace| |rbrace| & |stmt| \hfill $L\.{\\,}R$ & empty statement\cr
& |lbrace| |stmt| |rbrace| & |stmt|\cr
        \tspan $|force|\,L\,\\{in}\,|force|\,S\,
                |force|\,\\{back}\,R\,\\{out}\,|force|$ & compound statement\cr
& |lbrace| |exp| [|comma|] |rbrace| & |exp| & initializer\cr
& |if_like| |exp| & |else_like| \hfill $I\.{\ }E$ & |if (z)|\cr
& |else_like| |lbrace| & |if_head| |lbrace| & compound statement\cr
& |else_like| \alt|stmt| |exp| |else_like| & |else_like|\cr
\noalign{\vskip-6pt}
\tspan $|force|\,E\,\\{in}\,\\{bsp}\,S\,\\{out}\,|force|\,E\,\.\ \,|cancel|$ &
                                                        |if|-|else| clause\cr
& |else_like| |stmt| & |stmt|\hfill
   $|force|\,E\,\\{in}\,\\{bsp}\,S\,\\{out}\,|force|$ & |else|-less |if|\cr
\newprod{110}& |else_like| |else_like| & |else_like| \hfill $E_1\.\ E_2$ &
                           |else if|\cr
& |if_head| \alt|stmt| |exp| |else_like| & |else_like|\cr
\noalign{\vskip-6pt}
\tspan $|force|\,I\,\\{bsp}\,|noop|\,|cancel|\,S\,\\{bsp}\,E\,\.\ \,|cancel|$ &
                                                        |if|-|else| clause\cr
& |if_head| |stmt| & |stmt| \hfill
 $|force|\,I\,\\{bsp}\,|noop|\,|cancel|\,S\,|force|$ & |else|-less |if|\cr
& |do_like| |stmt| |else_like| |semi| & |stmt| \hfill
                        $D\,\\{bsp}\,S\,\\{bsp}\,E\,S$ & |do| statement\cr
& |case_like| |semi| & |stmt| & |return;|\cr
& |case_like| |exp| |semi| & |stmt| \hfill $C\.\ ES$ & |return 0;|\cr
& |case_like| |colon| & |tag| & |default:|\cr
& |case_like| |exp| |colon| & |tag| \hfill $C\.\ EC$ & |case 0:|\cr
& |tag| |tag| & |tag| \hfill $T_1\,\\{bsp}\,T_2$ & |case 0: case 1:|\cr
& |tag| \alt |stmt| |decl| & \alt |stmt| |decl| \hfill
        $|force|\,\\{back}\,T\,\\{bsp}\,S$ &
        \malt {|case 0: z=0;|} {|public: int x;|} \cr
& |stmt| \alt |stmt| |decl| & |stmt| \hfill $S_1\,|force|\,S_2$ &
         compound statement\cr
& |semi| & |stmt| \hfill \.\ $S$& empty statement\cr
& |lproc| \altt |if_like| |else_like| |define_like| & |lproc| &
         \maltt {{\bf \#include}} {\bf\#else} {\bf\#define} \cr
& |lproc| |rproc| & |insert| & {\bf\#endif} \cr
& |lproc| \alt {|exp| [|exp|]} |function| |rproc| & |insert| \hfill
    $I$\.\ \alt {$E{[\.{\ \\5}E]}$} {$F$} &
 \malt {{\bf\#define} $a$\enspace 1} {{\bf\#define} $a$\enspace$\{\,b;\,\}$} \cr
& |mod_scrap| |semi| & |stmt|\hfill $MS$ |force|
   &$\langle\,$mod name$\,\rangle$;\cr
& |mod_scrap| & |exp| &$\langle\,$mod name$\,\rangle$\cr
& |insert| |any| & |any| & \.{\v\#include\v}\cr
& |begin_arg| |end_arg| & |exp| & \.{@@[}\&{char}$*$\.{@@]}\cr
& |any_other| |end_arg| & |end_arg| &    \&{char}$*$\.{@@]}\cr
& |int_like| |comma| |exp| & |int_like| & \&{struct} |t|, |f|\cr % for offsetof
}
}
\endgroup
\yskip
\yskip\noindent The |force| in rule 55 becomes \\{bsp} if the \.{-f} option
is used when invoking \.{CWEAVE}.
The |define_like| case of production 57 also calls
|make_underlined| on the following scrap.
The trailing blank in rules 103~and~104 will be suppressed when immediately
followed by an |rpar|. Note that the additional rules for {\mc ANSI \Cee}
and \Cpp\ have their own numbering scheme beginning with no.~100.
